de.caff.generics.function

## Interface VarLongOperator

- Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface VarLongOperator

  Primitive long operator with a variable number of arguments.

  Although this basically works for a variable long array via the `apply(long...)` method implementors have to implement the method `apply(LongIndexable)` with a `LongIndexable` argument. This is done to make this class generally more useful without the need to copy arrays.

  Since:
    November 03, 2020
  Author:
    Rammi

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default long` | `apply(long... values)` Apply this operator.
    `long` | `apply(LongIndexable values)` Apply this operator.
    `static VarLongOperator` | `fromBinary(java.util.function.LongBinaryOperator binaryOp, long startValue)` Create an variable args operator from applying a binary operator over and over.

- - ### Method Detail

    - #### apply

          default long apply(long... values)

      Apply this operator. This default method forwards execution to `apply(LongIndexable)`.
      Parameters:
        `values` - arguments on which this operator is applied
      Returns:
        result of applying this operator to all arguments

    - #### apply

          long apply(@NotNull
                     LongIndexable values)

      Apply this operator.
      Parameters:
        `values` - indexable providing the values on which this operator operates
      Returns:
        result of applying this operator to all values

    - #### fromBinary

          @NotNull
          static VarLongOperator fromBinary(@NotNull
                                                     java.util.function.LongBinaryOperator binaryOp,
                                                     long startValue)

      Create an variable args operator from applying a binary operator over and over.

      Eg

      >      VarLongOperator maxOp = VarLongOperator.fromBinary(Math::max, Long.MIN_VALUE);
      >      long max = maxOp.apply(1L, -7L, -13L, 42L);

      On each application the currently accumulated result becomes the left (first) argument of `binaryOp`, while the run value becomes the right (second).
      Parameters:
        `binaryOp` - binary operator
        `startValue` - start value (result of operator if no values are given)
      Returns:
        variable long argument operator which applies the given binary operator over and over